"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServicesBearerTokenVerifyProvider = void 0;
const tslib_1 = require("tslib");
const rest_1 = require("@loopback/rest");
const jsonwebtoken_1 = require("jsonwebtoken");
const moment_timezone_1 = tslib_1.__importDefault(require("moment-timezone"));
class ServicesBearerTokenVerifyProvider {
    constructor() { }
    value() {
        return async (token) => {
            let user;
            try {
                user = jsonwebtoken_1.verify(token, process.env.JWT_SECRET, {
                    issuer: process.env.JWT_ISSUER,
                });
            }
            catch (error) {
                throw new rest_1.HttpErrors.Unauthorized("Token Invalid" /* TokenInvalid */);
            }
            if (user.passwordExpiryTime &&
                moment_timezone_1.default().isSameOrAfter(moment_timezone_1.default(user.passwordExpiryTime))) {
                throw new rest_1.HttpErrors.Unauthorized('PasswordExpiryError');
            }
            return user;
        };
    }
}
exports.ServicesBearerTokenVerifyProvider = ServicesBearerTokenVerifyProvider;
//# sourceMappingURL=services-bearer-token-verify.provider.js.map